package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.domain.po.MissionInfo;
import com.example.fuzzControll.domain.po.Test;
import com.example.fuzzControll.exception.mysqlException.MysqlException;
import com.example.fuzzControll.mapper.MissionInfoMapper;
import com.example.fuzzControll.mapper.TestMapper;
import com.example.fuzzControll.service.MissionInfoService;
import com.example.fuzzControll.tools.component.StringUtils;
import com.example.fuzzControll.tools.system.GlobalClass;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service("MissionInfoService")
@Slf4j
public class MissionInfoServiceImpl implements MissionInfoService {
    @Autowired
    MissionInfoMapper missionInfoMapper;
    @Autowired
    TestMapper testMapper;

    @Override
    @Transactional(rollbackFor = MysqlException.class)
    public boolean delMissionInfoById(int id) {
        /*删除任务需要同步删除测试里面的字段数据*/
        try {
            MissionInfo missionInfo = GlobalClass.missionInfoMapper.selectByMissionId(id);
            if(missionInfo==null){
                log.error("No mission id!");
                throw new RuntimeException();
            }
            missionInfoMapper.delMissionInfoById(id);
            int testId = missionInfo.getFatherId();
            //给mission整一个fatherid
            Test test = testMapper.getTestById(testId);
            String newMinssionIds = StringUtils.getArrayFormatStringAfterDelete(test.getMissionIds(), id);
            test.setMissionIds(newMinssionIds);
            testMapper.update(test);
            return true;
        } catch (Exception e) {
            log.error("Deleting mission info error:[{}]", e.getMessage());
            throw new MysqlException("");
        }
    }
}
